# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0.dev3
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class BaseTransactionDecline(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    decline_details: StrictStr = Field(..., description="Additional detail about the decline.")
    reason: StrictStr = Field(..., description="The reason the transaction was declined")
    __properties = ["decline_details", "reason"]

    @validator('reason')
    def reason_validate_enum(cls, v):
        if v not in ('ACH_RETURN', 'BALANCE_VIOLATION', 'DISABLED_PAYMENT_TYPE', 'DUPLICATE_TRANSACTION', 'GATEWAY_DECLINED', 'GATEWAY_ERROR', 'INSUFFICIENT_FUNDS', 'NETWORK_DECLINED', 'OTHER', 'SUSPECTED_FRAUD', 'TRANSACTION_NOT_PERMITTED'):
            raise ValueError("must validate the enum values ('ACH_RETURN', 'BALANCE_VIOLATION', 'DISABLED_PAYMENT_TYPE', 'DUPLICATE_TRANSACTION', 'GATEWAY_DECLINED', 'GATEWAY_ERROR', 'INSUFFICIENT_FUNDS', 'NETWORK_DECLINED', 'OTHER', 'SUSPECTED_FRAUD', 'TRANSACTION_NOT_PERMITTED')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BaseTransactionDecline:
        """Create an instance of BaseTransactionDecline from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BaseTransactionDecline:
        """Create an instance of BaseTransactionDecline from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return BaseTransactionDecline.parse_obj(obj)

        _obj = BaseTransactionDecline.parse_obj({
            "decline_details": obj.get("decline_details"),
            "reason": obj.get("reason")
        })
        return _obj

