# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0.dev3
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class WaitlistAnalytics(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    admitted: Optional[StrictInt] = Field(None, description="Total number of prospects that were admitted on the given day")
    created: Optional[StrictInt] = Field(None, description="Total number of prospects that signed up on the given day")
    var_date: Optional[StrictStr] = Field(None, alias="date", description="Date")
    deleted: Optional[StrictInt] = Field(None, description="Total number of prospects that were deleted on the given day")
    verified: Optional[StrictInt] = Field(None, description="Total number of prospects that were verified on the given day")
    withdrawn: Optional[StrictInt] = Field(None, description="Total number of prospects that were withdrawn on the given day")
    __properties = ["admitted", "created", "date", "deleted", "verified", "withdrawn"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WaitlistAnalytics:
        """Create an instance of WaitlistAnalytics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "admitted",
                            "created",
                            "var_date",
                            "deleted",
                            "verified",
                            "withdrawn",
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WaitlistAnalytics:
        """Create an instance of WaitlistAnalytics from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return WaitlistAnalytics.parse_obj(obj)

        _obj = WaitlistAnalytics.parse_obj({
            "admitted": obj.get("admitted"),
            "created": obj.get("created"),
            "var_date": obj.get("date"),
            "deleted": obj.get("deleted"),
            "verified": obj.get("verified"),
            "withdrawn": obj.get("withdrawn")
        })
        return _obj

