# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0.dev3
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from synctera_client.models.webhook_config import WebhookConfig

class WebhookResponse(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    active: Optional[StrictBool] = Field(None, description="indicates whether webhook is active")
    config: Optional[WebhookConfig] = None
    events: Optional[List[StrictStr]] = Field(None, description="list of webhook events, use * to receive all notifications")
    id: Optional[StrictStr] = Field(None, description="id of the webhook")
    name: Optional[StrictStr] = Field(None, description="name of the webhook")
    creation_time: Optional[datetime] = Field(None, description="The timestamp representing when the webhook request was made")
    last_modified_time: Optional[datetime] = Field(None, description="The timestamp representing when the webhook was last modified")
    __properties = ["active", "config", "events", "id", "name", "creation_time", "last_modified_time"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WebhookResponse:
        """Create an instance of WebhookResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "creation_time",
                            "last_modified_time",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WebhookResponse:
        """Create an instance of WebhookResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return WebhookResponse.parse_obj(obj)

        _obj = WebhookResponse.parse_obj({
            "active": obj.get("active"),
            "config": WebhookConfig.from_dict(obj.get("config")) if obj.get("config") is not None else None,
            "events": obj.get("events"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "creation_time": obj.get("creation_time"),
            "last_modified_time": obj.get("last_modified_time")
        })
        return _obj

